



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>python 调用 C++ code</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">python 调用 C++ code</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 16:41:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<div>
<p>本文以实例code讲解python 调用 C++的方法。&nbsp;<br />1. 如果没有参数传递从python传递至C++，python调用C++的最简单方法是将函数声明为C可用函数，然后作为C code被python调用，如<a href="http://stackoverflow.com/questions/145270/calling-c-c-from-python" rel="external nofollow noreferrer">这里</a>三楼所示；&nbsp;<br />2. 有参数传递至C++函数，swig是最便捷的调用方法，以下面这个工程所示为例；</p>
<hr />
<p>rachel.i (swig文件):</p>
<pre class="prettyprint linenums"><code>%module rachel<br />
%{<br />
#include "rachel.h"<br />
%}

extern int linear(int x, int w, int b);<br />
</code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li></ul>
<p>C++ code 部分：</p>
<p>rachel.h:</p>
<pre class="prettyprint linenums"><code>#include&lt;stdio.h&gt;<br />
#include&lt;Python.h&gt;                

int linear(int x, int w, int b);  </code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li>
<li>4</li></ul>
<p>rachel.cpp:</p>
<pre class="prettyprint linenums"><code>#include "rachel.h"       

int linear(int x, int w, int b){<br />
    int res = w * x + b;<br />
    printf("%d\n", res);<br />
    return res;<br />
}<br />
</code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li>
<li>4</li>
<li>5</li>
<li>6</li>
<li>7</li>
<li>8</li></ul>
<p>执行命令：</p>
<pre class="prettyprint linenums"><code>swig -c++ -python rachel.i<br />
g++ -c -fPIC rachel_wrap.cxx -I/home/zhangruiqing01/.jumbo/include/python2.7 -I./include<br />
g++ -shared rachel.o rachel_wrap.o -o _rachel.so<br />
</code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li>
<li>4</li></ul>
<p>第一句swig生成rachel_warp.cxx （如果是C，则用swig -python rachel.i生成rachel_warp.c文件）；&nbsp;<br />最后一句生成动态链接库_rachel.so供python调用（如果是C，则用ld -shared rachel.o rachel_warp.o -o _rachel.so）；</p>
<p>python 调用部分：</p>
<pre class="prettyprint linenums"><code>&gt;&gt;&gt; import _rachel<br />
&gt;&gt;&gt; _rachel.linear(1,2,5)<br />
7</code></pre>
<ul><li>1</li>
<li>2</li>
<li>3</li></ul>
<p>最后看一下本文中程序的结构：</p>
<p><img referrerpolicy="no-referrer"src="http://img.blog.csdn.net/20151024012039491" /></p>
</div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>from:&nbsp;http://blog.csdn.net/abcjennifer/article/details/49374307</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qx6jkzq.html">maven安装nexus私服</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96e00yq.html">CSS3 圆角制作的消息提示图标</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw31zz9.html">ubuntu更新删除旧内核的shell脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvx5lo8.html">Linq实现DataTable的分组统计</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wv65wq.html">iOS版 feedly 无法使用gmail账户的解决办法</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x1mp08.html">spring maven pom</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y0wd3q.html">Errore HTTP 404&period;2 - Not Found&amp;quot&semi; IIS 7&period;5 请求的内容似乎是脚本，因而将无法由静态文件处理程序来处理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kvvnz9.html">Android学习笔记（一）Git相关配置及使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpg2v0q.html">JS -- Variables As Properties</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z7lrn9.html">apollo实现c&num;与android消息推送&lpar;二&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv173moq.html">iOS 控制器的跳转、页面四个方向的跳转</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mxorj8.html">PyCharm下载及安装教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvvedy8.html">课程回顾-Convolutional Neural Networks</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o110neq.html">Keras 构建DNN 对用户名检测判断是否为非法用户名（从数据预处理到模型在线预测）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jp3xnq.html">LeetCode算法题-Reverse Bits（Java实现）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllook1q.html">js压箱底的宝贝</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjnn428.html">MT【176】两两乘积</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkvr3x8.html">C&plus;&plus; template &mdash;&mdash; 深入模板基础（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppkpp49.html">sql中字符串如何比大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em6mek9.html">反射方法调用时：参数计数不匹配（ parameter count mismatch ）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j0ejneq.html">Spring Mvc 输出Json&lpar;iwantmoon&period;com出品&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmom469.html">【BZOJ】【1211】【HNOI2004】树的计数</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xp0pe8.html">linux命令集&mdash;&mdash;&amp;lt&semi;一&amp;gt&semi;目录处理命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e10yoz9.html">Leetcode&num;127 Word Ladder</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjmd579.html">&lbrack;noip2005提高&rsqb;过河 dp</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnd25rq.html">web服务器与应用服务器</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pjmmw49.html">JS获取节点方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1d25j8.html">vi&sol;vim使用指北 ---- Beyond the Basic</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd4yke8.html">超快的 FastText</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1056e9.html">国内Jquery CDN</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
